use strict;
use vars qw($VERSION %IRSSI);

use Irssi;
$VERSION = '$Id: accent.pl,v 1.20 2002/10/09 11:12:16 toma Exp $';
%IRSSI = (
	authors     => 'Tamas SZERB',
	contact     => 'toma@rulez.org',
	name        => 'accent',
	description => 'This script strips the hungarian accents.',
	license     => 'GPL',
);

my $accent_tag = " [A]";
my $debug = 0;
my $accent_latin = "\301\341\311\351\315\355\323\363\326\366\325\365\332\372\334\374\333\373";
my $accent_ascii = "AaEeIiOoOoOoUuUuUu";
#iso 8859-2: A',a',E',e',I',i',O',o',O:,o:,O",o",U',u',U:,u:,U",u"


sub accent_out {
	my $emitted_signal = Irssi::signal_get_emitted();
	#FIXME supposing we're using unaccented cmd (including channel, etc infos)
	my ($cmd,$server,$item) = @_;

	if ($debug) {
		Irssi::print("signal emitted: $emitted_signal");
	}

	if ( $cmd =~ /[$accent_latin]/ ) {
		if ($debug) {
			Irssi::print("outgoing contains accent: $cmd");
		}
		eval "\$cmd =~ tr/$accent_latin/$accent_ascii/;";
		$cmd = $cmd . $accent_tag;
		Irssi::signal_emit("$emitted_signal", $cmd, $server, $item);
		Irssi::signal_stop();
	}
}

sub accent_in {
	my $emitted_signal = Irssi::signal_get_emitted();

	my ($server, $text, $nick, $address, $target) = @_;
	if ($debug) {
		Irssi::print("signal emitted: $emitted_signal");
	}
	if ( $text =~ /[$accent_latin]/ ) {
		if ($debug) {
			Irssi::print("incoming contains accent: $text");
		}
		if ($debug) {
			Irssi::print("text=$text");
		}
		$text = $text . $accent_tag;
		#no idea why w/o eval doesn't work:
		eval "\$text =~ tr/$accent_latin/$accent_ascii/;";
		if ($debug) {
			Irssi::print("text=$text");
		}
		Irssi::signal_emit("$emitted_signal", $server, $text, $nick, $address, $target);
		Irssi::signal_stop();

	}
}

#incoming filters:
#Irssi::signal_add('message private', 'accent_in');
#Irssi::signal_add('message public', 'accent_in');
#Irssi::signal_add('message irc action', 'accent_in');
#incoming, but unparesd (server, data):
#Irssi::signal_add('server incoming', 'accent_in');
#incoming, parsed (contains the server, data, sender_nick, sender_address):
Irssi::signal_add_first('server event', 'accent_in');

#output filters:
#only display:
#Irssi::signal_add_first('message own_public', 'accent_out');
#Irssi::signal_add_first('message own_private', 'accent_out');
#Irssi::signal_add_first('message own_action', 'accent_out');
#Irssi::signal_add('command msg', 'accent_out');
Irssi::signal_add_first('send command', 'accent_out');

#startup info:
Irssi::print("Hungarian accent stripper by toma * http://people.debian.org/~toma/accent.pl");
Irssi::print("Version: $VERSION");

