use Irssi 20020300;
use Irssi::Irc;
use strict;

use vars qw($VERSION %IRSSI); 
$VERSION = "1.0";
%IRSSI = (
	authors 	=> "Maciek \'fahren\' Freudenheim",
	contact 	=> "fahren\@bochnia.pl", 
	name 		=> "Antyidler",
	description 	=> "Antyidler with random time",
	license 	=> "GNU GPLv2 or later",
	changed		=> "Mon Nov 25 20:14:49 CET 2002"
);

# Changelog:
# 1.0
# - fixed that annoying "your_nick: is away blah blah" message

my $atimeout = Irssi::timeout_add(18000, 'antyidlesend', '');

sub antyidlesend {
	for my $server (Irssi::servers()) {
		$server->send_raw("PRIVMSG " . $server->{nick} . " IDLE");
		Irssi::timeout_remove($atimeout);
		$atimeout = Irssi::timeout_add(int(rand(180)+1)*1000, 'antyidlesend', '');
	}
}

Irssi::signal_add "event 301" => sub {
	my ($server, $data) = @_;

	my ($fnick, $snick, undef) = split(' ', $data);

	Irssi::signal_stop() if $fnick eq $snick;
};

Irssi::signal_add "default ctcp msg" => sub {
	my ($server, $data, $sender, $addr, $target) = @_;

	Irssi::signal_stop() if ($sender eq $target && $data eq "IDLE");
};
