# autocycle.pl,v 0.2 2002/10/02 10:50:15
# Usage: /SET auto_regain_ops [On/Off]
#        /autocycle

use strict;
use vars qw($VERSION %IRSSI);

use Irssi 20020313 qw( settings_add_bool settings_get_bool servers command_bind timeout_add );
$VERSION = "0.2";
%IRSSI = (
   authors      => "Marcin Rycki",
   contact      => "derwan\@irssi.pl",
   name         => "autocycle",
   description  => "Auto regain ops in empty opless channels",
   url          => "http://irssi.pl/~derwan/",
   license      => "GNU GPL v2",
   changed      => "Wed Oct  2 10:50:15 CEST 2002"
);

# void check_channels()
sub check_channels {
   foreach my $server (servers) {
      if ($server->{usermode} !~ m/r/ and my @channels = $server->channels) {
         CHANNEL: while (my $channel = shift @channels) {
            my $chnick = $channel->nick_find($server->{nick});
            if ($channel->{synced} && $channel->{modes} !~ m/a/ && $channel->{name} !~ m/^[\+\!]/ && $chnick && !$chnick->{op}) {
               foreach my $nick ($channel->nicks) {
                  ($nick->{nick} eq $server->{nick}) or goto CHANNEL;
               }
               $channel->print("Auto regain op in empty channel " . $channel->{name});
               $channel->command("cycle");
            }
         }
      }
   }
}

# void autocycle()
sub autocycle {
   if (settings_get_bool("auto_regain_ops")) {
      check_channels;
   }
}

# registering settings, binding command, runs timer
settings_add_bool "misc", "auto_regain_ops", 1;
command_bind "autocycle", "check_channels";
timeout_add 60000, \&autocycle, undef;
autocycle;

