use strict;
use Irssi;
use Irssi::TextUI;
use vars qw($VERSION %IRSSI);
use Xmms;
use Xmms::Remote ();

$VERSION = '1.342';
%IRSSI = (
	authors => 'Mikachu',
	contact => 'Mikachu @ quakenet|freenode',
	description => 'NEW FEATURE: Has a statusbar with scrolling title! Shows the title of the song playing in current channel, has lots of options. Please improve on this script if you want to, and give it to me and I\'ll put up the new version',
	name => 'l33t xmms music showing script',
	license => 'GPL',
	modules => 'Bundle::Xmms',
);

#this function from nickcolor.pl
my @colors = qw/2 3 4 5 6 7 9 10 11 12 13/;
sub simple_hash {
  my ($string) = @_;
  chomp $string;
  my @chars = split //, $string;
  my $counter;

  foreach my $char (@chars) {
    $counter += ord $char;
  }

  $counter = $colors[$counter % 11];

  return $counter;
}

#This subroutine is taken right from the rainbow.pl script, I haven't even
#looked at this code :)
my @colors = ('5', '4', '8', '9', '11', '12', '13');
sub make_colors {
	my ($string) = @_;
	my $newstr = "";
	my $last = 255;
	my $color = 0;

	for (my $c = 0; $c < length($string); $c++) {
		my $char = substr($string, $c, 1);
		if ($char eq ' ') {
			$newstr .= $char;
			next;
		}
		while (($color = int(rand(scalar(@colors)))) == $last) {};
		$last = $color;
		$newstr .= "\003";
		$newstr .= sprintf("%02d", $colors[$color]);
		$newstr .= (($char eq ",") ? ",," : $char);
	}

	return $newstr;
}

sub getvars {
	if ($_[0] eq "songinfo") {
		my ($position, $title, $time, $status, $filename);
		my $xmmscontrol = Xmms::Remote->new;
		$title = $xmmscontrol->get_playlist_title;
		my $seconds = ($xmmscontrol->get_output_time/1000)%60;
		my $tmp = length($seconds);
		if($tmp == "1") {
			$seconds = "0" . $seconds;
		}
		$position = int($xmmscontrol->get_output_time/60000) . ":" . $seconds;
		$time = $xmmscontrol->get_playlist_timestr;
		if ($xmmscontrol->is_playing) {
			if ($xmmscontrol->is_paused) {
				$status = "Paused";
			} else {
				$status = "Playing";
			}
		} else {
			$status = "Stopped";
		}
		$filename = $xmmscontrol->get_playlist_file;
		return($position, $title, $time, $status, $filename);
	}elsif ($_[0] =~ /^filename/) {
		my $xmmscontrol = Xmms::Remote->new;
		$_[0] =~ s/filename //;
		Irssi::active_win()->command("echo $_[0]");
		if ($_[0] eq "next") {
			$filename = $xmmscontrol->get_playlist_file(Xmms::Remote->new->get_playlist_pos + 1);
		} elsif ($_[0] eq "prev") {
			$filename = $xmmscontrol->get_playlist_file(Xmms::Remote->new->get_playlist_pos - 1);
		} else {
			$filename = $xmmscontrol->get_playlist_file;
		}
		return($filename);
	}
}

sub ctcp_info {
 if (Irssi::settings_get_str('l33tctcp_enabled') eq "enabled") {
	my ($server, $msg, $nick, $address, $channel) = @_;
	my ($p, $n, $t, $s) = getvars("songinfo");
	my $reply = Irssi::settings_get_str('l33tctcpreply');
	$reply =~ s/(\$\w+)/$1/eeg;
	$server->command("notice $nick $reply");
	Irssi::statusbar_items_redraw('l33tmusic');
 }
}

sub triggersend {
	my $trigger = Irssi::settings_get_str('l33ttrigger');
	if ($_[1] =~ /^$trigger/) {
		if (Irssi::settings_get_str('l33ttrigger_enabled') eq "enabled") {
			if ($_[1] =~ /^$trigger\s(next|prev)$/) {
				$_[1] =~ s/$trigger //g;
				$_[1] = getvars("filename $_[1]");
				if ($_[1]) {
					$_[0]->command("/DCC SEND $_[2] $filename");
				} else {
					$_[0]->command("notice $_[2] Sorry, no next/previous song in playlist.");
				}
			} else {
				my ($position, $title, $time, $status, $filename) = getvars("songinfo");
				$_[0]->command("notice $_[2] You are downloading $title (length $time)");
				$_[0]->command("/DCC SEND $_[2] $filename");
			} 
		} else {
			$_[0]->command("notice $_[2] Trigger currently disabled");
		}
	}
}

sub themainthingie {
	if (Xmms::Remote->new->is_running) {
		my ($msg, $server, $nick, $address, $channel) = @_;
		my $command;
		my ($p, $n, $t, $s, $f) = getvars("songinfo");
		#The -m switch will echo the info in current window,
		#I have this bound to meta-s :)
		if ($msg =~ "^-m\$") {
			print CLIENTCRAP "" . simple_hash("$n") . "$n ($p / $t)";
			$command = "";
		#This allows a fully customized message, to be used in
		#aliases, since it's not fun to write the full thing every
		#time
		} elsif ($msg =~ "^-e") {
			$msg =~ s/^\-e //;
			$command = "$msg";
		#The -c switch is a bit dangerous to use, if you use a string
		#that isn't a command in the Xmms::Remote module this script
		#will be unloaded
		} elsif ($msg =~ "^-c") {
			$msg =~ s/^\-c //;
			$msg = Xmms::Remote->new->$msg;
			$command = "echo \"$msg\"";
		#I don't really know how to make this work like it should,
		#but this'll have to do in the meantime, this show's stuff in
		#color, but doesn't allow you to customize the message yet,
		#since the colorize script destroys the "me" keyword with
		#colorcodes
		#(Ja Qerub, detta r "fulkod")
		} elsif ($msg =~ "^-f") {
			$msg =~ s/^\-f//;
			$msg =~ s/^ //;
			if ($msg) {
				$command = "me " . make_colors("$msg $n ($p / $t)");
			} else {
				$command = "me " . make_colors("lyssnar p $n ($p / $t)");
			}
		#This switch will send the currently playing song to
		#the nick on the command line, watch out with tab-complete
		#since it won't work with a trailing space on the nick
		} elsif ($msg =~ "^-s") {
			$msg =~ s/^-s //;
			$msg =~ s/ //;
			$server->command("/dcc send $msg $f");
		#If a string was given, put it in front of the info, and
		#anything after a # after the info
		} elsif ($msg) {
			my $msg2;
			$msg =~ s/(\$\w+)/$1/eeg;
			($msg, $msg2) = split "#", $msg;
			$command = "me $msg $n ($p / $t) $msg2";
		#Just go with the defaults
		} else {
			if ( $s eq "Playing" ) {
				$command = Irssi::settings_get_str('l33tstringplaying');
			} else {
				$command = Irssi::settings_get_str('l33tstringpaused');
			}
			$command = Irssi::settings_get_str('l33tstringaction') . " $command " . Irssi::settings_get_str('l33tstringsongformat');
		}
		$command =~ s/(\$\w+)/$1/eeg;
		$command =~ s/\s+/ /g;
		if ($command) {
			Irssi::active_win()->command("$command");
		}
	}else {
		Irssi::active_win()->command("echo Xmms isn't currently running");
	}
}

sub checkformpg123 {
	my ($msg, $server, $witem) = @_;
	if ($msg =~ /^Playing( MPEG stream from )?/) {
		$msg =~ s/Playing MPEG stream from //;
		$msg =~ s/Playing //;
		$msg =~ s/.mp3( \.\.\.)?//i;
		$msg =~ s/_/ /g;
		$msg =~ s/oc remix//i;
		$msg = Irssi::settings_get_str('l33tstringaction') . " " . Irssi::settings_get_str('l33tstringplaying') . " $msg";
		Irssi::signal_stop();
		Irssi::signal_remove('send text', 'checkformpg123');
		Irssi::signal_emit('send command', $msg, $server, $witem);
		Irssi::signal_add('send text', 'checkformpg123');
	}

}

my $statusbar_item;
my $refresh_tag;
my $scrollpos=0;
sub refresh_statusbar {
	my ($p, $no, $t, $s, $f) = getvars("songinfo");
	my $width=Irssi::active_win()->{width};
	my $n;
	my $others = Irssi::settings_get_str('l33tstatusbar');
	$others =~ s/\%.//g;
	$others =~ s/\$n//g;
	$others =~ s/(\$\w+)/$1/eeg;
	my $maxlength=$width - length($others); #length($s) - 5 - length($p) - length($t);
	if (length($no) > $maxlength) {
		my $middlethingie = Irssi::settings_get_str('l33tmiddlethingie');
		$no = "$no $middlethingie";
		$n=substr(substr($no, $scrollpos, length($no)) . substr($no, 0, $scrollpos), 0, $maxlength);
		$scrollpos++;
		$scrollpos=0 if ($scrollpos + 1 > length($no));
	} else {
		$n = $no;
	}
	$statusbar_item = Irssi::settings_get_str('l33tstatusbar');
	$statusbar_item =~ s/(\$\w+)/$1/eeg;
	Irssi::statusbar_items_redraw('l33tmusic');
}

sub l33tmusic_statusbar {
	my ($item, $get_size_only) = @_;
	$item->default_handler($get_size_only, "$statusbar_item", undef, 1);
}

Irssi::signal_add('send text', 'checkformpg123');
Irssi::command_bind('l33tmusic', 'themainthingie');
Irssi::settings_add_str('infopipe', 'l33tstringaction', '/me');
Irssi::settings_add_str('infopipe', 'l33tstringpaused', 'isn\'t listening to');
Irssi::settings_add_str('infopipe', 'l33tstringplaying', 'is listening to');
Irssi::settings_add_str('infopipe', 'l33tstatusbar', '$n ($p / $t)');
Irssi::settings_add_str('infopipe', 'l33tstatusbarrefresh', '500');
Irssi::settings_add_str('infopipe', 'l33tmiddlethingie', '*** ');
Irssi::settings_add_str('infopipe', 'l33tstringsongformat', '$n ($p / $t)');
Irssi::settings_add_str('infopipe', 'l33tctcpreply', 'I\'m listening to $n ($p / $t) Status: $s');
Irssi::settings_add_str('infopipe', 'l33ttrigger', 'yourtriggerhere');
Irssi::settings_add_str('infopipe', 'l33ttrigger_enabled', 'enabled');
Irssi::settings_add_str('infopipe', 'l33tctcp_enabled', 'enabled');
Irssi::signal_add("ctcp msg music", "ctcp_info");
Irssi::signal_add_last("message public", "triggersend");
Irssi::statusbar_item_register('l33tmusic', undef, 'l33tmusic_statusbar');
$refresh_tag=Irssi::timeout_add(Irssi::settings_get_str('l33tstatusbarrefresh'), 'refresh_statusbar', undef);	
print CLIENTCRAP "Type /set l33t to see all available settings. To remove this message, please delete the last two lines of the script. Type /l33tmusic to show what you're listening to.";
print CLIENTCRAP "If you want statusbar, add \'l33tmusic = { placement = \"top\"; items = { l33tmusic = { }; }; };\' to your config file, above \'topic = {\', and do a /reload.";
