use Irssi 20020916.1556 ();
use strict;

use vars qw($VERSION %IRSSI);

$VERSION="0.1.2";
%IRSSI = (
	authors=> 'BC-bd',
	contact=> 'bd@bc-bd.org',
	name=> 'thankop',
	description=> 'Remembers the last person oping you on a channel',
	license=> 'GPL v2',
	url=> 'http://bc-bd.org/software.php3#irssi',
);

#########
# USAGE
###
#
# Type '/thankop' in a channel window to thank the person opping you
#
################
###
# Changelog
#
# Version 0.1.2
#  - added version dependency, since some 0.8.4 users complained about a not working script
#  
# Version 0.1.1
#  - unsetting of hash values is done with delete not unset.
#
# Version 0.1.0
#  - initial release
#  
###
################

my %modes;
my %op;

sub cmd_thankop {
	my ($data, $server, $witem) = @_;

#	Irssi::print("$witem->{name}");

	if (exists($op{$witem->{name}})) {
		my $by = $op{$witem->{name}};
		$witem->command("/say $by: opthx");
	} else {
		$witem->print("thankop: I don't know who op'ed you in here");
	}
}

sub mode_changed {
	my ($channel, $nick, $by) = @_;

#	Irssi::print("me: $channel->{server}->{nick}, $nick->{nick} by $by $channel->{name}: $channel->{chanop}");

	return if ($channel->{server}->{nick} ne $nick->{nick});
	
	if ($modes{$channel->{name}} == 0 && $channel->{chanop}) {
#		Irssi::print("$channel->{name} op by $by");
		$op{$channel->{name}} = $by;
	}

	$modes{$channel->{name}} = $channel->{chanop};

#	Irssi::print("me: $channel->{server}->{nick}, $nick->{nick} by $by $channel->{name}: $channel->{chanop}");
}

sub channel_joined {
	my ($channel) = @_;

	$modes{$channel->{name}} = $channel->{chanop};
#	Irssi::print("$channel->{name}: $channel->{chanop}");
}

sub channel_destroyed {
	my ($channel) = @_;

	delete($modes{$channel->{name}});
	delete($op{$channel->{name}});
}

sub init_modes {
	foreach my $channel (Irssi::channels()) {
		if ($channel->{chat_type} eq 'IRC') {
			$modes{$channel->{name}} = $channel->{chanop};
		}
#		Irssi::print("$channel->{name}: $channel->{chanop}");
	}
}

init_modes();

Irssi::command_bind('thankop','cmd_thankop');
Irssi::signal_add_last('nick mode changed', 'mode_changed');
Irssi::signal_add_last('channel joined', 'channel_joined');
Irssi::signal_add_last('channel destroyed', 'channel_destroyed');
